
var aVzory:TStringList;
    aKese:TStringList;
    Counter:integer;
      //aObr:TStringList;   //IMG_ITEMS zaznamu pro obrazek
    aImg:array of T_IMGINFO; //informace o ibrazcich se spoilery
    nImg:integer;       //pocet vyuzitych polozek v aImg
    nSpoilers:integer;  //pocet zpracovanych spoileru
    sGpx:string;
    ImcDB:TSqliteDatabase; //Geogeti databaze s obrazky

function GetMyDir:string;
begin Result:=GEOGET_SCRIPTDIR+'\Spoiler\'; end;

{$include Spoiler.cfg.pas}

function GetOfflineDir:string;       //vraci Offline adresar (download, obrazky, ...)
begin Result:=RelToAbsPath(DIR_OFFLINE+'\',GEOGET_DATADIR+'\'); end;

function GetTransformDir:string; //vraci Offline adresar pro transformovane obrazky
begin
  Result:=GetOfflineDir()+'Cache_'+IntToStr(rCfg.bAutorotate as integer)
    +IntToStr(rCfg.bAspectRatio as integer)+'-'
    +IntToStr(rCfg.iWidth)+'x'+IntToStr(rCfg.iHeight)+'\';
end;

function GetDownloadDir:string;       //vraci Offline adresar (download, obrazky, ...)
begin Result:=RelToAbsPath(DIR_DOWNLOAD+'\',GEOGET_DATADIR+'\'); end;

function GetTmpDir:string;       //vraci Tmp adresar
begin Result:=RelToAbsPath(DIR_TMP+'\',GEOGET_DATADIR+'\'); end;

function GetSpoilerDir:string;       //vraci adresar s pripravenym GPX spoileru
begin  Result:=RelToAbsPath(rCfg.sPoiDir+'\',GEOGET_DATADIR+'\');end;

function GetSpoilerImgDir:string;       //vraci adresar s obrazky pripravenymi spoilery
begin Result:=GetSpoilerDir+'Imgs\';end;

function GetSpoilerVersion:string;
begin
  Result:=GeoGetPackageVersion(ReplaceString(GEOGET_SCRIPTFULLNAME,'.ggp.pas','.meta.ini'));
end;

function RemoveID(filename:string):string; //odstrani pocatecni kod kese ve jmenu souboru
begin
  Result:=RegExSubstitute('_(.*)$',filename,'$1');
end;

function ImcGetName():string;  //vrati jmeno souboru databaze.imc (podle aktualni databaze
begin
  Result:=GEOGET_DBNAME+'.imc';
end;

procedure ImcClose;
begin
  if(ImcDb<>nil) then begin
    ImcDB.Commit('Spoiler'); //commitneme zmeny
    ImcDb.Free();
  end;
end;

function ImcOpen():boolean;    //otevre geogeti databazi obrazku, pokud neni, vytvori ji
var b:boolean;
    s:string;
begin
  if(ImcDB=nil) then begin
    s:=GEOGET_DATADIR+'\'+ImcGetName();
    b:=FileExists(s);
    try
      if(not b) then begin
{$ifdef DEBUG_HELPER}
  LDH('ImcOpen(): vytvarim databazi '+s);
{$endif}
        ImcDB:=TSqliteDatabase.Create(s);
        ImcDB.ExecSQL('CREATE TABLE images (key INTEGER PRIMARY KEY, '
                    +' url TEXT, dtupdate REAL DEFAULT 0,lastmodified TEXT,data BLOB)');
        ImcDB.ExecSQL('CREATE UNIQUE INDEX imgurlidx ON images (url)');
        ImcDB.ExecSQL('CREATE INDEX imgdtidx ON images (dtupdate)');
        ImcDB.ExecSQL('CREATE TABLE imgindex (key INTEGER PRIMARY KEY, id TEXT, ptrkey INTEGER DEFAULT 0)');
        ImcDB.ExecSQL('CREATE INDEX imgididx ON imgindex (id)');
        ImcDB.ExecSQL('CREATE INDEX imgptridx ON imgindex (ptrkey)');
      end
      else begin
        ImcDB:=TSqliteDatabase.Create(s);
      end;
      //v kazdem pripade zahajime transakci, aby byl zapis rychlejsi a nemohlo
      //dojit k nekonzistenci
      ImcDB.Start('Spoiler','');
    finally
    end;
  end;
  Result:=(ImcDB<>nil);
end;

function ImcAddImg(Id,url,img:string):boolean; //prida obrazek do databaze
var dt:extended;
    rowid,key:int64;
begin
  //zkontrolujeme, zda existuje pro kesku obrazek a podle toho jej prepisu nebo pridam
  Result:=true;
{$ifdef DEBUG_HELPER}
  LDH('ImcAddImg(): '+'Id='+id+', Url='+url{+', Img='+img});
{$endif}
  ImcOpen();
  ImcDB.AddParamText(':id',id);
  ImcDB.AddParamText(':url',url);
  dt:=ImcDB.GetTableValue('SELECT dtupdate FROM images im,imgindex idx'
    +' WHERE im.url=:url AND im.key=idx.ptrkey AND idx.id=:id');
  try
    //vraci 0, pokud obrazek neexistuje nebo datun a cas posledni aktualizace obrazku
    //pridat vetu do images, precist LastInsertRowID: int64;
    //z teto vety ziskat id a zapsat jej do tabulky imgindex
{$ifdef DEBUG_HELPER}
  LDH('dtupdate: '+FloatToStr(dt));
{$endif}
    if(dt=0) then begin
      ImcDB.AddParamText(':url',url);
      ImcDB.AddParamText(':modi','');
      ImcDB.AddParamFloat(':dt',now());
      ImcDB.AddParamBlobText(':img',img);
      ImcDB.ExecSQL('INSERT INTO images(url,dtupdate,lastmodified,data) VALUES (:url,:dt,:modi,:img)');
      rowid:=ImcDB.LastInsertRowID();
      ImcDB.AddParamInt(':rowid',rowid);
      key:=ImcDB.GetTableValue('SELECT key FROM images WHERE rowid=:rowid');
{$ifdef DEBUG_HELPER}
  LDH('rowid='+IntToStr(rowid)+', key='+IntToStr(key));
{$endif}
      ImcDB.AddParamText(':id',id);
      ImcDB.AddParamInt(':key',key);
      ImcDB.ExecSQL('INSERT INTO imgindex(id,ptrkey) VALUES (:id,:key)');
      dt:=now();
    end;
    if(dt<=now()-10) then begin //aktualizovat stary obrazek
{$ifdef DEBUG_HELPER}
  LDH('aktualizace obrazku');
{$endif}
      ImcDB.AddParamText(':id',id);
      ImcDB.AddParamText(':url',url);
      rowid:=ImcDB.GetTableValue('SELECT im.rowid FROM images im,imgindex idx'
        +' WHERE im.url=:url AND im.key=idx.ptrkey AND idx.id=:id');
      ImcDB.AddParamInt(':rowid',rowid);
      ImcDB.AddParamFloat(':dt',now());
      ImcDB.AddParamBlobText(':img',img);
      ImcDB.ExecSQL('UPDATE images SET data=:img, dtupdate=:dt WHERE rowid=:rowid');
    end;
  finally ;
  end;
end;

function FirstUpName(name:string):string;
var s:string;
  i,v:integer;
begin
  Result:='';
  v:=1;
  name:=LowerCase(name);
  for i:=1 to length(name) do
  begin
    s:=copy(name,i,1);
    if((s=' ') or (s='+') or (s=';') or (s='\') or (s='/')
      or (s='>') or (s='<') or (s='=')) then v:=1
    else begin
      if(v=1) then Result:=Result+UpperCase(s)
      else Result:=Result+s;
      v:=0;
    end;
  end;
end;

function GetImgDirectlyDir(sID:string):string; //vytvori adresar pro prime nahravani obrazku do GPS
var i:Integer;
begin
  i:=length(sID);
  Result:='';
  case rCfg.eExportType of
  ENUM_IMG: begin
          if(i=0) then Result:=rCfg.sImgDir+'\Garmin\GeocachePhotos'
          else begin
            Result:=rCfg.sImgDir+'\Garmin\GeocachePhotos\'+copy(sID,i,1)+'\';  //posleni znak
            if(i<4) then Result:=Result+'0'      //predposledni znak, pokud je kratke ID
            else Result:=Result+copy(sID,i-1,1);            //predposledni znak
          end;
        end;
  ENUM_ATTACH: if(i=0) then Result:=GEOGET_DATADIR+'\attach'
            else Result:=GEOGET_DATADIR+'\attach\'+copy(sID,i,1);  //posleni znak
  end;
  if(i>0) then begin
    Result:=Result+'\'+sID;                        //ID kese
    if((rCfg.bSubdir) or (rCfg.eExportType=ENUM_ATTACH)) then Result:=Result+'\Spoilers';
  end;
  Result:=Result+'\';
end;

function SpoilerInit:integer;
var s,s1:string;
    i:integer;
begin
  // pustime busy dialog, at to neco dela a nevypada, ze to zatuhlo
{$ifdef DEBUG_HELPER}  LDH('SpoilerInit() - 1'); {$endif}
  Result:=1;
  nSpoilers:=0;
  sGpx:='';
  Counter:=0;
  GeoBusyStart;
  GeoBusyProgress(0, Geoget_MaxCount);

  if(gsUsername='') then begin
    // #. if(not rCfg.bSilent) then ShowMessage('Nevyplnn hodnota gsUserneme v "groundspeak.config.pas".');
    if(not rCfg.bSilent) then ShowMessage(_('Blank gsUsername in "groundspeak.config.pas".'));
    Result:=0;
  end;

  //vytvorime seznam hledanych jmen spoileru
  aVzory:=TStringList.Create();
  case (rCfg.ePattern) of
    ENUM_REGEX: s:=rCfg.sPatternRegex;
    ENUM_SUBSTRING: s:=rCfg.sPatternSubstr;
  end;
  s:=AnsiToUtf(s);
  while(s<>'') do begin
    s1:=UpperCase(UtfToAscii(trim(fetch(s,','))));
    if(s1<>'') then aVzory.Add(s1);
  end;
  //pokud se nektery ze spoileru '*'=vsechny obrazky, pak ostatni vyhodime
  for i:=0 to aVzory.Count-1 do begin
    if(aVzory[i]='*') then begin
      i:=aVzory.Count;
      aVzory.Clear();
      aVzory.Add('*');
    end;
  end;

  //vytvorime seznam kesi v seznamu
  s:=GetTmpDir()+'SpoilerList.ggt';
  GeoListSave(s);
  if(not FileExists(s)) then StringToFile('',s);
  aKese:=TStringList.Create();
  aKese.LoadFromFile(s);
  DeleteFiles(s);

  //vytvorit potrebne adresare a pokud je to pozadovano, vymazat je
{$ifdef DEBUG_HELPER}  LDH('SpoilerInit() - vytvoreni adresaru'); {$endif}
  ForceDirectories(GetTmpDir());          //vytvorit adresar pro pracovni soubory
  DeleteFiles(GetTmpDir()+'*.*');
  ForceDirectories(GetDownloadDir());     //vytvorit adresar pro stahovani listingu
  DeleteFiles(GetDownloadDir()+'*.*');
  ForceDirectories(GetOfflineDir());      //vytvorit adresar pro offline
  //pokud je pozadovano, vycistit adresar pro offline
{$ifdef DEBUG_HELPER}  LDH('SpoilerInit() - vymazani adresaru, pokud je pozadovano'); {$endif}
//{$ifdef DEBUG_HELPER}  LDH('SpoilerInit() - cilovy adresar (pri ENUM_POI) nemazeme, aby bylo mozne predavat'); {$endif}
  if((rCfg.eEraseOfflineDir=ENUM_START) or (rCfg.eEraseOfflineDir=ENUM_ALWAYS)) then begin
    DelTree(GetOfflineDir());
    ForceDirectories(GetOfflineDir());
  end;
  ForceDirectories(GetTransformDir());      //vytvorit adresar pro transformovane obrazky
  //pokud je pozadovano, vycistit adresar s transformovanymi obrazky
  if((rCfg.eEraseTransformDir=ENUM_START) or (rCfg.eEraseTransformDir=ENUM_ALWAYS)) then begin
    DelTree(GetTransformDir());
    ForceDirectories(GetTransformDir());
  end;
  //vycistime cilovy adresar pro vystup
  case rCfg.eExportType of
  ENUM_POI: begin
          ForceDirectories(GetSpoilerImgDir());  //vytvorit adresar pro GPX a obrazky
          DeleteFiles(GetSpoilerDir()+'*.*');    //vycistit adresar pro GPX
          DeleteFiles(GetSpoilerImgDir()+'*.*'); //vycistit adresar pro obrazky
         end;
  ENUM_IMG: begin
          //vymazeme hlavni adresar pro Geocaching with Photos
          ForceDirectories(GetImgDirectlyDir(''));  //vytvorit adresar pro obrazky
          DelTree(GetImgDirectlyDir(''));           //vymazat
          ForceDirectories(GetImgDirectlyDir(''));  //vytvorit adresar pro obrazky
         end;
  //ENUM_IMC:; //neni co cistit, je nesmysl smazat celou databazi
  ENUM_ATTACH: begin
          //adresare nelze vymazat, protoze v tuto chvili neni znamo ID kese
          //k urceni adresare a nemuzeme vymazat vsechny prilohy vsem kesim
          //ForceDirectories(GetImgDirectlyDir(''));  //vytvorit adresar pro obrazky
          //DeleteFiles(GetImgDirectlyDir('')+'*.*'); //vycistit adresar pro GPX
         end;
  end;
end;

procedure GeoJarry(sImport:TStringList); //pres GJ importuje listingy kesi v seznamu
var s:string;
    res:integer;
begin
  //vytvorit ini pro GJ
  s:='[geojarry]'+CRLF
     +'username='+gsUsername+CRLF
     +'password='+gsPassword+CRLF
     +'proxyip='+GEOGET_PROXYHOST+CRLF
     +'proxyport='+GEOGET_PROXYPORT+CRLF
     +'proxyuser='+GEOGET_PROXYUSER+CRLF
     +'proxypass='+GEOGET_PROXYPASS+CRLF
     +'datadir='+GetDownloadDir()+CRLF
     +'gpx=1'+CRLF      //pro GJ 2.3+
     +'sessionfile='+GetTmpDir()+'gj_session.txt'+CRLF
     ;
  StringToFile(s,GetTmpDir()+'gj_spoiler.ini');
  sImport.SaveToFile(GetTmpDir()+'gj_spoiler.ggt');
  s:=GEOGET_SCRIPTDIR+'\geojarry\geojarryw.exe';
  if(not FileExists(s)) then s:=GEOGET_DATADIR+'\geojarryw.exe';
  if(not FileExists(s)) then begin
    // #. if(not rCfg.bSilent) then ShowMessage('Nenalezen geojarryw.exe');
    if(not rCfg.bSilent) then ShowMessage(_('File not found: geojarryw.exe'));
  end
  else begin
    s:='"'+s+'" "'+GetTmpDir()+'gj_spoiler.ini"'
      +' caches'
      +' "'+GetTmpDir()+'gj_spoiler.ggt"'
      ;
    StringToFile(s,GetTmpDir()+'gj_spoiler.cmd');
    //begin a end zobrazi informaci o poctu iportovanych kesi, v tomto pripade by to chtelo potlacit
    res:=RunExec(s);
    if(res=0) then begin
      GeoImportBegin();
      GeoImportDir(GetDownloadDir());
      //GeoImportEnd();  //zobrazi statistiky o importu, ale to ja nechci
      GeoImportBegin();  //vynulujeme statistiky importu, aby se to nepocitalo nekomu jinemu
    end
    else if(not rCfg.bSilent) then ShowMessage(_('GeoJarry error: ')+IntToStr(res)+CRLF+s);
  end;
end;

procedure GetLinkSpoilers;  //nacte informace o spoilerech pro seznam kesi
var g:TGeo;
    i,j,iPoradi:integer;
    s,obr,jmeno,odkaz,fileName,vzor:string;
    sImport:TStringList;
begin
  g:=TGeo.Create();
  sImport:=TStringList.Create();
  // #. GeoBusyCaption('Krok 1/5 - Kontrola zdroje listingu');
  GeoBusyCaption(_('Step 1/5 - Checking source format of listings'));
{$ifdef DEBUG_HELPER}  LDH('Step 1/5 - 1, rezim importu listingu='+IntToStr(rCfg.eUpdate as integer)); {$endif}
  //if(LISTING_IMPORT<>'No') then begin
  if(rCfg.eUpdate<>ENUM_NOUPDATE) then begin
//{$ifdef DEBUG_HELPER}  LDH('Step 1/5 - 2'); {$endif}
    for i:=0 to aKese.Count-1 do begin
      GeoBusyProgress(i+1,aKese.Count);                // obsluha busy dialogu
      g.LoadByGC(aKese[i]);
      if GeoBusyTest then GeoAbort;
      //pokud ukladame primo obrazky k priloham, vymazeme adresar Spoileru kese
      if(rCfg.eExportType=ENUM_ATTACH) then begin
        if(FileExists(GetImgDirectlyDir(aKese[i])+'*.*')) then
          DeleteFiles(GetImgDirectlyDir(aKese[i])+'*.*'); //vycistit adresar
      end;
      //25.9.2011 - stahovat jen pokud neexistuje zadny TAG_IMPORT
      //v tom pripade byl import ve formatu, ktery neobsahuje zadne info o obrazku
      {s:=g.TagValues(TAG_IMPORT);}
      //case UpperCase(LISTING_IMPORT) of
      case rCfg.eUpdate of
      ENUM_TAG_GCIMAGE: begin
                 if((g.TagValues(TAG_SPOILER)='') {and (not RegexFind('\.GC.*\.htm[l]*\s*$',s))}) then begin
{$ifdef DEBUG_HELPER}  LDH('Step 1/5 - 1, neni tag '+TAG_SPOILER+', import kese: '+aKese[i]); {$endif}
                   sImport.Add(aKese[i]);
                 end;
               end;
      ENUM_ALWAYS:   begin
{$ifdef DEBUG_HELPER}  LDH('Step 1/5 - 1, vzdy importovat, import kese: '+aKese[i]); {$endif}
                 sImport.Add(aKese[i]);
               end;
      ENUM_DAYS: begin
                 //##--!! tady by se spravne melo kontrolovat, zda uz keska nebyla pridana !!!
                 if(rCfg.iDays>0) then begin //#####
                   if((Now-g.updated)>rCfg.iDays) then begin
{$ifdef DEBUG_HELPER}  LDH('Step 1/5 - 1, import kese pri prekroceni stari listingu: '+aKese[i]); {$endif}
                     //ShowMessage('WWWWW='+floatToStr(Now-g.updated)+CRLF+'rCfg.iDays='+intToStr(rCfg.iDays));
                     sImport.Add(aKese[i]);
                   end;
                 end;
               end;
      end;
    end;
  end;
{$ifdef DEBUG_HELPER}  LDH('Step 1/5 - 2, pocet kesi k importu: '+IntToStr(sImport.Count)); {$endif}
  if(sImport.Count>0) then begin
{$ifdef DEBUG_HELPER}  LDH('Step 1/5 - 2, importovat pres ['+IntToStr(rCfg.eUpdateListing as integer)+']'); {$endif}
    case rCfg.eUpdateListing of
    ENUM_GEOJARRY: begin
{$ifdef DEBUG_HELPER}  LDH('Step 1/5 - 2, import listingu pomoci GJ'); {$endif}
            GeoBusyCaption(_('Step 1/5 - Importing listings using GeoJarry: ')+IntToStr(sImport.Count));
            GeoJarry(sImport);
            end;
    ENUM_GCLIVE: begin
{$ifdef DEBUG_HELPER}  LDH('Step 1/5 - 2, import listingu pomoci GC.Live'); {$endif}
              GeoBusyCaption(_('Step 1/5 - Importing listings via API: ')+IntToStr(sImport.Count));
              GcLiveUpdateListing(sImport.Text, false);
              end;
    end;
  end;
  sImport.Free();
//{$ifdef DEBUG_HELPER}  LDH('Step 1/5 - 4'); {$endif}


  // #. GeoBusyCaption('Krok 2/5 - Kontrola existence spoileru/obrazku');
  GeoBusyCaption(_('Step 2/5 - Searching listings for spoiler images'));
{$ifdef DEBUG_HELPER}  LDH('Step 2/5 - hledani spoileru podle vzoru jmena'); {$endif}
  j:=0;
  nImg:=0;            //v poli neni zadny obrazek
  for i:=0 to aKese.Count-1 do begin
{$ifdef DEBUG_HELPER}  LDH('Step 2/5 - 1'); {$endif}
    if GeoBusyTest then GeoAbort;
    GeoBusyProgress(i+1,aKese.Count);     // obsluha busy dialogu
    g.LoadByGC(aKese[i]);
    if(g.TagHaveCategory(TAG_SPOILER))then begin
{$ifdef DEBUG_HELPER}  LDH('Step 2/5 - 2'); {$endif}
      s:=g.TagValues(TAG_SPOILER);
      GeoBusyKind(UtfToAnsi(g.Name));
      if(s='X') then s:='';
      iPoradi:=0;
      while(s<>'') do begin  //projdeme vsechny obrazky k teto kesi
        obr:=fetch(s,CRLF);
        //separujeme z tagu odkaz a jmeno
        jmeno:=RegexReplace('(?i)(<a.*?>)(.*?)</a>',obr,'$2',true);
        odkaz:=RegexReplace('.*?"(.*?)".*',obr,'$1',true);
{$ifdef DEBUG_HELPER}
        LDH('Step 2/5 - 3 Obr: '+obr+CRLF+', jmeno:'+jmeno+CRLF+', odkaz:'+UtfToAscii(odkaz));
{$endif}
        //pokud neobsahuje tag <a>...</a>, zahodime to
        if(jmeno=obr) then begin jmeno:=''; odkaz:=''; end;

         //zjistime, zda jmeno obsahuje jako substring neco z hledaneho
        j:=0;
          if(odkaz<>'') then begin
{$ifdef DEBUG_HELPER}  LDH('Step 2/5 - pocet vzoru='+IntToStr(aVzory.Count)); {$endif}
            while j<aVzory.Count do begin
              vzor:=aVzory[j];
{$ifdef DEBUG_HELPER}  LDH('Step 2/5 - test vzoru='+vzor); {$endif}
              if(vzor='*') then j:=aVzory.Count+100
              else begin
                case (rCfg.ePattern) of
                  ENUM_REGEX: if(RegexFind(vzor,UtfToAscii(jmeno))) then j:=aVzory.Count+100;
                  ENUM_SUBSTRING: if(Pos(vzor,UpperCase(UtfToAscii(jmeno)))>=1) then j:=aVzory.Count+100;
                end;
              end;
{$ifdef DEBUG_HELPER}
              LDH('FFFFF'+CRLF+'Vzor:'+vzor+', jmeno:'+UpperCase(UtfToAscii(jmeno))+CRLF+'j='+IntToStr(j));
{$endif}
              j:=j+1;
            end;
          end;
          //pokud nas toto jmeno zajima
          if(j=aVzory.Count+101) then begin
            iPoradi:=iPoradi+1;
            //ze jmena vyhodime pripadne odradkovani
            jmeno:=RegexReplace('(?i)<br\ */*>',jmeno,'',false);
            fileName:=g.ID+'_';
            //jmeno souboru musi obsahovat i GC kod, protoze jinak se stejne
            //pojmenovane obrazky (napr. Spoiler) prepisuji
            //if(rCfg.eExportType<>ENUM_POI) then fileName:='';
            fileName:=fileName+FirstUpName(UtfToAscii(jmeno));
            //ze jmena vypustime nepovolene znaky
            fileName:=RegexReplace('[\\<>&#/!;,.:@$%?\|^''"*\[\]\(\)]',fileName,'',false);
            //Pozorjed (http://www.geocaching.cz/forum/viewthread.php?forum_id=20&thread_id=15142&pid=246565#post_246565)
            //mel navrh zkratit jmeno na 32 znaku a doplnit poradovym cislem.
            //Zkraceni neni problem, ale cislo zalezi na tom, v jakem poradi se
            //nacte z TAGu nebo to zavisi na nastaveni klicovych slov (ruzny pocet
            //nalezenych spoileru). To by prineslo pri kazdem spusteni ruzna
            //jmena souboru a nenajdu je v cache, zbytecne se budou stahovat, ...
            //Pokud vynecham cislo, nemusi byt mozna 32 znaku dost na rozliseni.
            //I ted zrejme mohou existovat stejna jmena u vice obrazku na jedne
            //kesi (nic nebrani tomu dat 3 obrazkum popis 'Fotohint')
            //fileName:=copy(fileName,1,StrToInt(rCfg.iNameMaxLength)-3)+'_'+FormatFloat('00',iPoradi)+'.jpg'; //zkratime na 32 (29+3) znaku, doplnime poradi;
            fileName:=copy(fileName,1,rCfg.iNameMaxLength)+'.jpg'; //zkratime na povolenou delku
            //kontrola, zda je misto pro ulozeni obrazku v poli
            if(Length(aImg)<=nImg+1) then SetLength(aImg,Length(aImg)+1000);
            aImg[nImg].iIndex:=i;
            aImg[nImg].sName:=jmeno;
            aImg[nImg].sUrl:=odkaz;
            aImg[nImg].sFilename:=fileName;
            //zjistime, zda je nutne obrazek stahovat
            aImg[nImg].bDownload:=((rCfg.bReloadImg) or (not FileExists(GetOfflineDir()+fileName)));
            Inc(nImg);
            j:=-1;
            // ##--##

          end;
      end;
    end;
  end;
  //kontrolni vypis seznamu spoileru
{$ifdef DEBUG_HELPER}
  for i:=0 to nImg-1 do begin
    LDH('Spoiler '+IntToStr(i)+': '+CRLF
      +'    index: '+IntToStr(aImg[i].iIndex)+CRLF
      +'    jmeno spoileru: '+aImg[i].sName+CRLF
      +'    URL: '+aImg[i].sUrl+CRLF
      +'    jmeno souboru: '+aImg[i].sFilename+CRLF
      +'    stahnout?: '+IntToStr(aImg[i].bDownload as integer)+CRLF
      );
  end;
{$endif}
  g.Free();
end;

procedure GetFileSpoilers;  //nacte obrazky z webu a ulozi je do offline adresare
var  i,j:integer;
     s,s1:string;
begin
  // #. GeoBusyCaption('Krok 3/5 - Stahovani obrazku z webu: ')+IntToStr(aObr.Count div IMG_ITEMS);
  GeoBusyCaption(_('Step 3/5 - Downloading images from web: ')+IntToStr(nImg));
  ForceDirectories(GetOfflineDir());
  for i:=0 to nImg-1 do begin
    if GeoBusyTest then GeoAbort;
    GeoBusyProgress(nImg,i);     // obsluha busy dialogu
    GeoBusyKind(aImg[i].sFilename);
    j:=1;                        //predpokladame stazeni obrazku z webu
    //obrazek nebudeme z webu stahovat pokud:
    // - je v exportnim adresari
    // - je v offline adresari GG
    // - je v imc databazi
    // - je v transformacnim adresari
    //pokud neco z toho plati, obrazek nacteme a ulozime do GetOfflineDir()+aImg[i].sFilename
{$ifdef DEBUG_HELPER} LDH('bUseOfflineDir='+IntToStr(rCfg.bUseOfflineDir as integer)); {$endif}
    if(rCfg.bUseOfflineDir) then begin
      s:='';
      if(FileExists(GetOfflineDir()+aImg[i].sFilename)) then begin
{$ifdef DEBUG_HELPER} LDH('Obrazek nalezen v '+GetOfflineDir()); {$endif}
        j:=0;
      end;
      if(j=1) and (FileExists(GetImgDirectlyDir(aKese[aImg[i].iIndex])+aImg[i].sFilename)) then begin
{$ifdef DEBUG_HELPER} LDH('Obrazek nalezen v '+GetImgDirectlyDir(aKese[aImg[i].iIndex])); {$endif}
        CopyFile(GetImgDirectlyDir(aKese[aImg[i].iIndex])+aImg[i].sFilename,
          GetOfflineDir()+aImg[i].sFilename);
        j:=0;
      end;
      if(j=1) then begin //zkusime offline adresar GG
        s1:=aKese[aImg[i].iIndex];
        s:=GEOGET_DATADIR+'\offline\inc\'
          +copy(s1,length(s1),1) //posledni pismeno kodu kese
          +'\'+s1+'-'
          //##-- +RegexReplace('.*/',aObr[i+IDX_LINK],'',false)
          +RegexReplace('.*/',IntToStr(aImg[i].iIndex),'',false)
          ;
        if(FileExists(s)) then begin   //prekopirujeme z GeoGetiho offline adresare
{$ifdef DEBUG_HELPER} LDH('Obrazek nalezen v '+s); {$endif}
          CopyFile(s,GetOfflineDir()+aImg[i].sFilename);
          j:=0;
        end;
      end;
      if(j=1) then begin //zkusime imc databazi
      end;
    end;
    if(j=1) then begin //nenacitat ani kdyz je v transfomacnim adresari
      s1:=RegexReplace('(.*)\..*?$',aImg[i].sFilename,'$1.jpg',true);
      if(FileExists(GetTransformDir()+s1)) then begin
{$ifdef DEBUG_HELPER} LDH('Obrazek nalezen v '+GetTransformDir()); {$endif}
        j:=0;
      end;
    end;

    if(j=1) then begin              //stahneme obrazek, pokud je to potreba
{$ifdef DEBUG_HELPER}
      LDH('Stahuji obrazek: '+aImg[i].sUrl);
      LDH('Ulozit ho do: '+GetOfflineDir()+aImg[i].sFilename);
{$endif}
      if((HttpAsk('GET',aImg[i].sUrl,'image/jpeg','',s))) then
        StringToFile(s,GetOfflineDir()+aImg[i].sFilename) //ulozit do offline
      else if(not rCfg.bSilent) then ShowMessage(_('ERR: Downloading picture from web.')+CRLF+aImg[i].sFilename);
    end;
  end;
end;

procedure SaveFileSpoilers; //ulozi (a otoci) spoilery ve spravne velikosti do adresare pro Transformovane obrazky a pro POI-GPX
var  i,iImgWidth,iImgHeight,iImgBpp:integer;
     sImg:ansistring;
     sObrName,sImgType,sImgDirectlyDir:string;
     fx,fy:extended;
     g:TGeo;
begin
  // #. GeoBusyCaption('Krok 4/5 - Transformace a ulozeni obrazku: ')+IntToStr(aObr.Count/IMG_ITEMS);
  GeoBusyCaption(_('Step 4/5 - Transforming and saving pictures: ')+IntToStr(nImg));
  //cilovy adresar uz je vymazan z SpoilerInit (krome exportu do ATTACH,
  //tam nemuzeme smazat vsechno a neni jasne, ktere kese bychom mazat meli
  g:=TGeo.Create();
  for i:=0 to nImg-1 do begin
    if GeoBusyTest then GeoAbort;
    GeoBusyProgress(nImg,i);     // obsluha busy dialogu
    GeoBusyKind(aImg[i].sFilename);
    //nacteme obrazek, abychom zjistili rozmery pro indikaci otoceni
{$ifdef DEBUG_HELPER} LDH('SaveFileSpoilers(): '+'rCfg.eExportType='+IntToStr(rCfg.eExportType as integer)+', Pracujeme s: '+GetOfflineDir()+aImg[i].sFilename); {$endif}
    sObrName:=RegexReplace('(.*)\..*?$',aImg[i].sFilename,'$1.jpg',true);
    if(FileExists(GetTransformDir()+sObrName)) then begin//je v cache? rovnou zkopirovat pro GPX-POI
     case rCfg.eExportType of
      ENUM_POI: begin
               CopyFile(GetTransformDir()+sObrName,GetSpoilerImgDir()+(sObrName));
               Inc(nSpoilers);
             end;
      ENUM_IMC: begin
               ImcAddImg(aKese[aImg[i].iIndex], aImg[i].sUrl,FileToString(GetTransformDir()+sObrName));
             end;
      ENUM_IMG,
      ENUM_ATTACH: begin
             sImgDirectlyDir:=RelToAbsPath(GetImgDirectlyDir(aKese[aImg[i].iIndex]),GEOGET_DATADIR);
             ForceDirectories(sImgDirectlyDir);
             CopyFile(GetTransformDir()+sObrName,sImgDirectlyDir+RemoveID(sObrName));
             Inc(nSpoilers);
             end;
      end;
    end
    else begin
      if(FileExists(GetOfflineDir()+aImg[i].sFilename)) then begin
{$ifdef DEBUG_HELPER} LDH('SaveFileSpoilers(): UUUUU 1 - nacteni obrazku'); {$endif}
        sImg:=FileToString(GetOfflineDir()+aImg[i].sFilename); //nacteme obrazek
        //vymazeme EXIF (zmensi se tim obrazek a prestane dela problemy s nahledy)
{$ifdef DEBUG_HELPER} LDH('SaveFileSpoilers(): UUUUU 2 - Remove Exif'); {$endif}
        sImg:=ImageExifRemove(sImg);
{$ifdef DEBUG_HELPER} LDH('SaveFileSpoilers(): UUUUU 3 - Convert do JPG (length='+IntToStr(length(sImg))+')'); {$endif}
        sImg:=ImageConvert(sImg,'jpg');   //prevedeme obrazek do jpg
        if(rCfg.eExportType<>ENUM_IMC) then begin //dalsi manipulace delame jen kdyz neni zapis do databaze
          //zjistime rozmery obrazku
{$ifdef DEBUG_HELPER} LDH('SaveFileSpoilers(): UUUUU 4 - ImageInfo obrazku'); {$endif}
          ImageInfo(sImg,sImgType,iImgWidth,iImgHeight,iImgBpp);
          if(rCfg.bAutorotate) then begin
            if(iImgWidth>iImgHeight) and (rCfg.iWidth<rCfg.iHeight) then begin
{$ifdef DEBUG_HELPER} LDH('SaveFileSpoilers(): UUUUU 5a - Autorotate'); {$endif}
              sImg:=ImageRotate(sImg,90);
            end;
            if(iImgWidth<iImgHeight) and (rCfg.iWidth>rCfg.iHeight) then begin
{$ifdef DEBUG_HELPER} LDH('SaveFileSpoilers(): UUUUU 5b - Autorotate'); {$endif}
              sImg:=ImageRotate(sImg,90);
            end;
          end;
          //menime velikost jen u velkych obrazku, pro databazi nechame vzdy puvodni
          if(rCfg.bResize) and ((iImgWidth>rCfg.iWidth) or (iImgHeight>rCfg.iHeight)) then begin
            if(rCfg.bAspectRatio) then begin
{$ifdef DEBUG_HELPER} LDH('SaveFileSpoilers(): UUUUU 6a - ImageResize'); {$endif}
              sImg:=ImageResize(sImg,rCfg.iWidth,rCfg.iHeight,true,true);
            end
            else begin
{$ifdef DEBUG_HELPER} LDH('SaveFileSpoilers(): UUUUU 6b - ImageResize'); {$endif}
              sImg:=ImageResize(sImg,rCfg.iWidth,rCfg.iHeight,false,true);
            end;
          end;
          //GPS tam uz ale nejsou, jsou odstraneny
{$ifdef DEBUG_HELPER} LDH('SaveFileSpoilers(): UUUUU 7 - Cteni GPS z EXIF'); {$endif}
          ImageGPSRead(sImg,fx,fy);
          if(fx=0) and (fy=0) then begin //pridame informaci o souradnicich do EXIF (jen kdyz tam neni)
            g.LoadByGC(aKese[aImg[i].iIndex]); //nacteme informace o kesi
            if(rCfg.bCorrected) then begin fx:=g.CorrectedCoordXNum; fy:= g.CorrectedCoordYNum; end
            else begin fx:=g.CoordXNum; fy:=g.CoordYNum; end;
{$ifdef DEBUG_HELPER} LDH('SaveFileSpoilers(): UUUUU 8 - Zapis GPS do EXIF'); {$endif}
            sImg:=ImageGPSWrite(sImg,fx,fy);
          end;
        end;
{$ifdef DEBUG_HELPER} LDH('SaveFileSpoilers(): UUUUU 9 - Zapis do souboru v TransformDir('+GetTransformDir()+')'); {$endif}
        StringToFile(sImg,GetTransformDir()+sObrName);  //ulozime do cache
{$ifdef DEBUG_HELPER} LDH('SaveFileSpoilers(): UUUUU 9b - existuje soubor v offline?='
  +IntToStr(FileExists(GetOfflineDir()+aImg[i].sFilename) as integer)); {$endif}
        case rCfg.eExportType of
        ENUM_IMC: begin
                 ImcAddImg(aKese[aImg[i].iIndex], aImg[i].sUrl,FileToString(GetTransformDir()+sObrName));
               end;
        ENUM_POI: begin
{$ifdef DEBUG_HELPER} LDH('SaveFileSpoilers(): UUUUU 10a - Zapis do souboru v SpoilerImgDir ('+GetSpoilerImgDir()+')'); {$endif}
               StringToFile(sImg,GetSpoilerImgDir()+(sObrName)); //ulozime pro GPX-POI
               Inc(nSpoilers);
               end;
        ENUM_IMG,
        ENUM_ATTACH: begin
               sImgDirectlyDir:=RelToAbsPath(GetImgDirectlyDir(aKese[aImg[i].iIndex]),GEOGET_DATADIR);
               ForceDirectories(sImgDirectlyDir);
{$ifdef DEBUG_HELPER} LDH('SaveFileSpoilers(): UUUUU 10b - Zapis do souboru v GetImgDirectlyDir() ('+sImgDirectlyDir+')'); {$endif}
               StringToFile(sImg,sImgDirectlyDir+RemoveID(sObrName));
               Inc(nSpoilers);
               end;
        end;
      end;
    end;
  end;
  g.Free();
  if(ImcDB<>nil) then ImcClose();
end;

procedure GenerateGpx;
var g:TGeo;
    i,j:integer;
    s,s1,id:string;
    azimut,x,y,krok,xnew,ynew:extended;
begin
  // #. GeoBusyKind('Krok 5/5 - Generovani GPX pro POILoader');
  GeoBusyKind(_('Step 5/5 - Creating GPX for POILoader'));
  //pro kazdou kes, ktera ma spoiler vezmeme
  azimut:=0;
  krok:=(0.+rCfg.iDistance)/1000.; //hodnota musi byt v kilometrech
  g:=TGeo.Create();
  id:='';
  for i:=0 to nImg-1 do begin
    if GeoBusyTest then GeoAbort;
    GeoBusyProgress(nImg,i);     // obsluha busy dialogu
    GeoBusyKind(aImg[i].sFilename);
    g.LoadByGC(aKese[aImg[i].iIndex]); //nacteme informace o kesi
    if(g.id=id) then j:=j+1  //poradi spoileru u kese
    else j:=1;
    id:=g.id;
    //vypocteme souradnice POI bodu s fotospoilerem
    //  pocitame od korigovanych souradnic, tedy finalky, pokud je
    if(rCfg.bCorrected) then begin x:=g.CorrectedCoordXNum; y:= g.CorrectedCoordYNum; end
    else begin x:=g.CoordXNum; y:=g.CoordYNum; end;
    
    PointProject(x,y,azimut+(0.+i)*(0.+rCfg.iAzimut),krok,xnew,ynew);
    s:=aImg[i].sFilename+CRLF;
    if(rCfg.bIdTag) then s:=s+'<br /><b>Cache: </b>'+g.IdTag+' '+g.Name+CRLF;
    if(rCfg.bHint) then s:=s+'<br /><b>Hint: </b>'+UtfToAscii(g.Hint)+CRLF;
    case rCfg.eExportType of
    ENUM_POI: s1:=GetSpoilerImgDir()+aImg[i].sFilename;
    ENUM_IMG: s1:=GetSpoilerImgDir()+RemoveID(aImg[i].sFilename);
    //pro ATTACH se GPX nevytvari, nemuze se sem dostat
    //'ATTACH': s1:=GetSpoilerImgDir()+RemoveID(aObr[i+IDX_FILENAME]);
    end;
    //prekodujeme znaky, ktere se nemaji vyskytnout v ceste
    s1:=copy(s1,1,2)+EncodeUrlElement(copy(s1,3,length(s1)));
    s1:=ReplaceString(s1,'%5C','/');  //vratime zpet lomitka (ale v tagu museji byt normalni)
    //zapiseme informace o bodu
    sGpx:=sGpx
      +ReplaceString('<wpt lat="'+FormatFloat('0.0000000',xnew) //v souradnicich nahradime desetinnou carku teckou
        +'" lon="'+FormatFloat('0.0000000',ynew)+'">',',','.')+CRLF
      //delku jmena omezime na 13 znaku, aby se vse veslo na 1 radek a mohl byt obrazek vetsi
      //+'  <name>'+CDATA(g.ID+' - '+copy(UtfToAscii(g.Name),1,13))+'_+'</name>'+CRLF
      +'  <name>'+CDATA(g.ID+' '+copy(UtfToAscii(g.Name),1,10)+'_'+FormatFloat('00',j))+'</name>'+CRLF
      +'  <cmt></cmt>'+CRLF
      +'  <desc>'+CDATA(s)+'</desc>'+CRLF
      +'  <link href="'+s1+'" />'+CRLF //vsechna lomitka museji byt normalni, cesta musi byt absolutni!
      +'</wpt>'+CRLF;
  end;
  g.Free();
{$ifdef DEBUG_HELPER} LDH('SaveFileSpoilers(): UUUUU X - existuje soubor v offline?='
  +IntToStr(FileExists(GetOfflineDir()+aImg[0].sFilename) as integer)); {$endif}
end;

procedure SpoilerWork;
begin
  // #. GeoBusyCaption('Priprava GPX se spoilery/obrazky pro POILoader');
  GeoBusyCaption(_('Preparing Spoilers'));
{$ifdef DEBUG_HELPER}  LDH('Spoustim GetLingSpoilers()'); {$endif}
  GetLinkSpoilers();  //zjistime vsechny spoilery pro kese v seznamu
  GetFileSpoilers();  //nacteme soubory s obrazky, pokud je treba je nacist
  SaveFileSpoilers(); //ulozime spoilery do POI-GPX adresare
  if(rCfg.eExportType=ENUM_POI) then  GenerateGpx();      //vygenerujeme GPX soubor pro POILoader
end;

function GpxHeader:string;
begin
  Result:='<?xml version="1.0" encoding="utf-8" standalone="no" ?>'+CRLF
         +'<gpx '+CRLF
         +'  creator="'+GeoGet_Version+', Spoiler generator '+GetSpoilerVersion()+'"'+CRLF
         +'  version="1.1"'+CRLF
         +'  xmlns="http://www.topografix.com/GPX/1/1"'+CRLF
         +'  xmlns:gpxx="http://www.garmin.com/xmlschemas/GpxExtensions/v3"'+CRLF
         +'  xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance"'+CRLF
         +'  xsi:schemaLocation="http://www.garmin.com/xmlschemas/GpxExtensions/v3 http://www.garmin.com/xmlschemas/GpxExtensions/v3/GpxExtensionsv3.xsd http://www.topografix.com/GPX/1/1 http://www.topografix.com/GPX/1/1/gpx.xsd">'
         +CRLF+CRLF;
end;

function GpxFooter:string;
begin
  Result:='</gpx>'+CRLF;
end;

procedure SpoilerStop; //pokud neni zadny spoiler, nastavi retez sGpx=''
var s:string;
begin
  if(Length(aImg)>0) then SetLength(aImg,0);
  if(aVzory<>nil) then aVzory.Free();
  if(aKese<>nil) then aKese.Free();
  if(rCfg.eExportType=ENUM_POI) then  begin
    if(sGpx<>'') then sGpx:=GpxHeader()+sGpx+GpxFooter();
    //zkopirovat ikonu do spravneho adresare
    CopyFile(rCfg.sIconPathname,ReplaceString(GetSpoilerDir()+rCfg.sOutFilename,'.gpx','.bmp'));
  end;
  //pokud je pozadovano, vycistit adresar s offline
  if((rCfg.eEraseOfflineDir=ENUM_END) or (rCfg.eEraseOfflineDir=ENUM_ALWAYS)) then begin
    DelTree(GetOfflineDir());
    ForceDirectories(GetOfflineDir());
  end;
  //pokud je pozadovano, vycistit adresar s transformovanymi obrazky
  if((rCfg.eEraseTransformDir=ENUM_END) or (rCfg.eEraseTransformDir=ENUM_ALWAYS)) then begin
    DelTree(GetTransformDir());
    ForceDirectories(GetTransformDir());
  end;
end;
